#include <cstdio>
#include <algorithm>
#include <vector>
#include <cassert>


using namespace std;

typedef pair<int,int> PI;


PI random_pair_len(int begin, int end, int len)
{
    int k = random()%(end-begin)+1;
    int p = random()%(end-begin-k+1);
    assert(k>0);
    return PI(begin+p,begin+p+k);
}

PI random_pair(int begin, int end)
{
    int a, b;
    do
    {
      a = begin+random()%(end-begin+1);
      b = begin+random()%(end-begin+1);
    }
    while (a==b);
    if (a>b)
        swap(a,b);
    assert(a<b);
    return PI(a,b);
}


void gen_ends(int n, int maxh, int maxw, int len)
{
    vector<int> A;
    for(int i=0; i<6*n; i++)
        A.push_back(random()%maxw+1);
    sort(A.begin(),A.end());
    A.erase(unique(A.begin(),A.end()),A.end());
    random_shuffle(A.begin(),A.end());
    if (A.size()<2*n)
    {
        fprintf(stderr,"%d %d %d\n",n,maxw,A.size());
    }
    assert(A.size()>=2*n);
    sort(A.begin(),A.begin()+2*n);
    printf("%d\n",n);
    for(int i=0; i<n; i++)
    {
        PI p;
        if (len==-1)
            p = random_pair(0,2*n-1);
        else
            p = random_pair_len(0,2*n-1,len);
        printf("%d %d %d\n",A[p.first],A[p.second],random()%maxh+1);
    }
}

void gen_fullrandom(int n, int maxh, int maxw, int len)
{
    printf("%d\n",n);
    for(int i=0; i<n; i++)
    {
        PI p;
        if (len==-1)
            p = random_pair(1,maxw);
        else
            p = random_pair_len(1,maxw,len);
        printf("%d %d %d\n",p.first,p.second,random()%maxh+1);
    }    
}

void gen_stairs(int n)
{
    printf("%d\n",n);
    for(int i=1; i<=n; i++)
        printf("%d %d %d\n",2*i,2*i+3,3*i+1);

    printf("%d\n",n);
    for(int i=0; i<n; i++)
        printf("%d %d %d\n",10*i+1,20*n-i,2*i+1);

    printf("%d\n",n);
    for(int i=0; i<n/2; i++)
        printf("%d %d %d\n",i+1, 3*n+i+1,n+i);
    for(int i=n/2; i<n; i++)
        printf("%d %d %d\n",n+i+1, 2*n+i+1,2*n+i);

    assert(n%3==0);
    printf("%d\n",n);
    for(int i=0; i<n/3; i++)
    {
        printf("%d %d %d\n",i+1,3*n-2*i,i+1);
        printf("%d %d %d\n",3*n-2*i-1,3*n+2*i+1,2*n-i);
        printf("%d %d %d\n",3*n+2*i+2,6*n+i,3*i+1);
    }
}


int main()
{
    srand(1364);
    int tn;
    
    scanf("%d",&tn);
    switch(tn)
    {
    
    case 1:
    printf("%d\n",240);
    for(int q = 0; q < 30; q++)
    {
        gen_ends(11+random()%10,100,100,5);
        gen_ends(11+random()%10,100,100,q%10+2);
        gen_ends(11+random()%10,100,100,-1);
        gen_fullrandom(11+random()%10,200,30,10);
        gen_fullrandom(11+random()%10,200,30,40);
        gen_fullrandom(11+random()%10,200,30,-1);
    }
    for(int q = 0; q < 10; q++)
    {
        gen_ends(51+random()%50,300,1000,5);
        gen_ends(51+random()%50,300,1000,q%10+2);
        gen_ends(51+random()%50,300,1000,-1);
        gen_fullrandom(51+random()%50,1000,1000,10);
        gen_fullrandom(51+random()%50,1000,1000,80);
        gen_fullrandom(51+random()%50,1000,1000,-1);
    }
    break;
    
    case 2:
    printf("%d\n",9);
    gen_ends(300,10000,10000,5);
    gen_ends(299,10000,10000,-1);
    gen_fullrandom(300,10000,10000,100);
    gen_fullrandom(300,10000,10000,1500);
    gen_fullrandom(300,10000,10000,-1);
    gen_stairs(300);
    break;
    }
}
