#include <stdlib.h>
// Author: Lech Duraj

#include <cstdio>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>

#define dprintf(...)
//#define dprintf(...) fprintf(stderr,__VA_ARGS__)

using namespace std;


typedef pair<int,int> PI;

const int maxn = 100*1000;

int pal[maxn];
char S[maxn+3];

int uniform(int n)
{
    if (n==1)
        return 1;
    return 1 + n%2 + uniform(n/2);
}

int greedy(char* A, int n)
{
    
    if (n<=1)
        return n;
    int f = 0;
    int best = 0;
    pal[0] = 0;
    bool is_uniform = true;
    for(int i=0; i<n; i++)
        is_uniform &= (A[i]==A[0]);
    if (is_uniform)
        return uniform(n);
    for(int i=1; i<n; i++)
    {
        if (f+pal[f]>i)
        {
            int j = f - (i - f);
            pal[i] = pal[j];
            int over = i+pal[i]-f-pal[f];
            if (over>0)
                pal[i] -= over;
        } 
        else
            pal[i] = 0;
        while(i+pal[i]<n && i-pal[i]>0 && A[i+pal[i]]==A[i-pal[i]-1])
        {
            pal[i]++;
            f = i;
        }
        if (pal[i]>pal[best])
            best = i;
    }
    int len = pal[best];
    vector<PI> s;
    for(int i=0; i<n; i++)
        s.push_back(PI(i,pal[i]));
    int result = n;
    for (PI k : s)
        result = min(result, 1 + n - 2*k.second + greedy(A+k.first,k.second));
    return result;
}


int main()
{
    int TT;
    scanf("%d\n",&TT);
    while(TT--)
    {
        fgets(S,maxn+2,stdin);
        int n = strlen(S);
        n--;
        S[n] = 0;
        printf("%d\n",greedy(S,n));
    }
}
