// Author: Szymon Gut
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <map>
#define mp make_pair
using namespace std;
#define M 1000000009
typedef long long lolo;
#define ZR ('a'-1)
#define QM ('z'+1)
#define FORC(c,a,b) for(char c=(a); c<=(b); ++c)
#define N 1000010

char A[N], B[N], C[N];

struct aux_t {
	int ll, le, el, ee;
	int wl, we, lw, ew, ww;
	aux_t() : ll(0), le(0), el(0), ee(0), wl(0), we(0), lw(0), ew(0), ww(0) {}
};

struct res_t {
	lolo ll, le, el, ee;
	res_t() : ll(0), le(0), el(0), ee(0) {}
};

struct win {
	pair<char, pair<char,char>> t;
	bool operator<(const win& w) const {
		return t < w.t;
	}
	explicit win(char a=0, char b=0, char c=0) : t(mp(a,mp(b,c))) {}
};

//map<win,aux_t> auxmap;
aux_t auxtab[QM+1][QM+1][QM+1];


void decide(aux_t& aux, char a, char b, char c) {
	aux.ww++;
	if(a < b) {
		aux.lw++;
		if(b < c)
			aux.ll++;
		else if(b == c)
			aux.le++;
	}
	else if(a==b) {
		aux.ew++;
		if(b < c)
			aux.el++;
		else if(b == c)
			aux.ee++;
	}
	if(b < c)
		aux.wl++;
	else if(b == c)
		aux.we++;
}

void fill(char* s, int i, aux_t& aux) {
	if(i==3) return decide(aux, s[0], s[1], s[2]);
	if(s[i] != QM) return fill(s, i+1, aux);
	for(char c='a'; c<='z'; ++c) {
		s[i] = c;
		fill(s, i+1, aux);
	}
	s[i] = QM;
}

void comp_aux() {
	FORC(a,ZR,QM) FORC(b,ZR,QM) FORC(c,ZR,QM) {
		aux_t aux;
		char s[3] = {a,b,c};
		fill(s, 0, aux);
		//auxmap[win(a,b,c)] = aux;
		auxtab[a][b][c] = aux;
	}
}

char tr(char c) {
	if(c=='?') return QM;
	if(c==0) return ZR;
	return c;
}

lolo test() {
	scanf("%s%s%s", A, B, C);
	int n = max(strlen(A), max(strlen(B), strlen(C)));
	for(int i=strlen(A); i<=n; ++i)
		A[i] = 0;
	for(int i=strlen(B); i<=n; ++i)
		B[i] = 0;
	for(int i=strlen(C); i<=n; ++i)
		C[i] = 0;
	
	
	res_t res; res.ee = 1;
	for(int i=0; i<n; ++i) {
		//aux_t aux = auxmap[win(tr(A[i]), tr(B[i]), tr(C[i]))];
		aux_t aux = auxtab[tr(A[i])][tr(B[i])][tr(C[i])];
		res_t nres;
		//printf("%c%c%c [%d]\n", tr(A[i]), tr(B[i]), tr(C[i]), aux.ll);
		
		nres.ee = (res.ee*aux.ee) % M;
		nres.le = (res.ee*aux.le + res.le*aux.we) % M;
		nres.el = (res.ee*aux.el + res.el*aux.ew) % M;
		nres.ll = (res.ee*aux.ll + res.le*aux.wl + res.el*aux.lw + res.ll*aux.ww) % M;
		
		res = nres;
	}
	return res.ll;
}

int main() {
	comp_aux();
	int t; scanf("%d", &t);
	while(t--) {
		printf("%lld\n", test());
	}
}
