// Author: Lech Duraj

#include "ver.h"
#include <cstdio>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

const int maxn = 1000;
const int maxr = 10000;

int sq(int x)
{
    return x*x;
}

int main() 
{
    oi::Scanner in(stdin);
    int TT = in.readInt(1, 1e9);
    in.readEoln();
    for(int tt=1; tt<=TT; tt++)
    {
        int n = in.readInt(1,maxn);
        vector<int> X(n),Y(n),R(n);
        in.readEoln();
        for(int i=0; i<n; i++)
        {
            X[i] = in.readInt(-maxr,maxr);
            in.readSpace();
            Y[i] = in.readInt(-maxr,maxr);
            in.readSpace();
            R[i] = in.readInt(1,maxr);
            in.readEoln();
        }
        
        for(int i=0; i<n; i++)
            for(int j=i+1; j<n; j++)
                if (i!=j && sq(X[i]-X[j])+sq(Y[i]-Y[j])<sq(R[i]+R[j]))
                {
                    char message[200];
                    sprintf(message,"Test %d - kola %d i %d zachodza na siebie!",tt,i,j);
                    in.error(message);
                }
                
        queue<int> Q;
        vector<int> parent(n,-1);
        vector<int> dist(n,-1);
        Q.push(0);
        dist[0] = 0;
        parent[0] = -1;
        int md = 0;
                
        while(!Q.empty())
        {
            int u = Q.front();
            Q.pop();
            for(int i=0; i<n; i++)
            {
                if (i!=u && dist[i]!=-1 && i!=parent[u] && sq(X[i]-X[u])+sq(Y[i]-Y[u])==sq(R[i]+R[u]) && ((dist[i]-dist[u])%2==0))
                {
                    char message[200];
                    sprintf(message,"Test %d - cykl nieparzysty!",tt);
                    in.error(message);
                }
                if (dist[i]==-1 && sq(X[i]-X[u])+sq(Y[i]-Y[u])==sq(R[i]+R[u]))
                {
                    parent[i] = u;
                    dist[i] = dist[u]+1;
                    md = max(md,dist[i]);
                    Q.push(i);
                }
            }
        }
        
        printf("Test %d: OK, n = %d, maxdist = %d.\n",tt,n,md);
    }
    in.readEof();
    puts("OK!");
    return 0;
}
