#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cassert>

using namespace std;

int rnd(int a, int b)
{
    return a+random()%(b-a+1);
} 

#define dprintf(...) fprintf(stderr,__VA_ARGS__)


const int infty  = 1e9;

void gen_random(int TT,int maxn,int maxk,int range)
{
    while(TT--)
    {
        int n = maxn - random()%(maxn/5+1);
        int k;
        if (TT%10>=7)
            k = random()%(maxk+1);
        else
            k = maxk - random()%(maxk/3+1);
        printf("%d %d\n",n,k);
        int R = max(k,2)*range;
        if (TT%10==2)
            R = range;
        for(int i=0; i<n; i++)
            printf("%d %d\n",random()%R,random()%range);
    }
}

void gen_special(int n, int k, int range)
{
    vector<int> A(n,0);
    for(int i=0; i<=k; i++)
        A[i] = 1;
    random_shuffle(A.begin(),A.end()-1);
    printf("%d %d\n",n,k);
    vector< vector<int> > B(k+1);
    vector<int> value(n);
    vector<int> cost(n);
    for(int q=0; q<=k ;q++)
        B[q].resize(n+1,-range);
    value[n-1] = range;
    cost[n-1] = 2*range/(k+2);
    B[0][n-1] = value[n-1]-cost[n-1];
    int q = 0;
    dprintf("%d %d\n",value[n-1],cost[n-1]);
    for(int i=n-2; i>=0; i--)
    {
        switch(A[i])
        {
            case 1:
                if (q==0)
                {
                    value[i] = value[i+1];
                    cost[i] = rnd(0,value[i]-B[0][i+1]-1);
                    q++;
                } else
                { 
                    assert(q<k+1);              
                    value[i] = min(value[i+1],B[q-1][i+1]-1);
                    cost[i] = rnd(0,value[i]-B[q][i+1]-1);
                    q++;
                }
                dprintf("%d [%d %d]\n",i,value[i],cost[i]);
                break;
            case 0:
                if (q==0 || q>k)
                {
                    int s = min(q,k);
                    value[i] = value[i+1]-1;
                    cost[i] = value[i]-B[s][i+1]+1;
                    break;
                }
                value[i] = value[i+1]-1;
                cost[i] = min(value[i],B[q-1][i+1])-B[q][i+1]+1;
                break;
        }
        B[0][i] = max(value[i]-cost[i],B[0][i+1]);
        for(int s=1; s<=k; s++)
            B[s][i] = max(B[s][i+1], min(value[i]-cost[i],B[s-1][i+1]-cost[i]));
    }
    vector<int> C(n);
    for(int i=0; i<n; i++)
        C[i] = i;
    random_shuffle(C.begin(),C.end());
    for(int i=0; i<n; i++)
        printf("%d %d\n",value[C[i]],cost[C[i]]);
}

int main()
{
    srand(12835);
    printf("130\n");
    gen_random(100,20,5,100);
    gen_random(20,1000,6,10000);
    gen_random(5,150000,9,100000);
    gen_special(100,5,1000);
    gen_special(1000,6,100000);
    gen_special(10000,7,1000000);
    gen_special(150000,9,1000000);
    gen_special(150000,9,1000000);
}
