#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)4e3+11;
const int maxm = (int)1e6;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n, m;
int parent[maxn], p[maxm];
pii e[maxm];
int tin[maxn];
int timer;
int P[12][maxn];
int lca[maxm];
vector < int > g[maxn];
int level[maxn];
int L[maxn], R[maxn];
int T[4*maxn];

void dfs(int v, int par, int degree){
	parent[v] = par;
	level[v] = degree;
	L[v] = tin[v] = timer++;
	forit(it, g[v]){
		int to = *it;
		if ( to == par ) continue;
		dfs(to, v, degree+1);
	}
	R[v] = timer-1;
}

void update(int v, int tl, int tr, int l, int r, int val){
	if ( l > tr || r < tl ) return;
	if ( l <= tl && tr <= r){
		T[v] |= val;
		return;
	}
	int mid = (tl + tr)/2;
	update(2*v, tl, mid, l, r, val);
	update(2*v+1, mid+1, tr, l, r, val);
}

int get(int v, int tl, int tr, int pos, int sum = 0){
	if(tl > tr) return 0;
	sum |= T[v];
	if ( tl == tr ) return sum;
	int mid = (tl + tr)/2;
	if ( pos <= mid ){
		return get(2*v, tl, mid, pos, sum);
	}		
	else
		return get(2*v+1, mid+1, tr, pos, sum);
}

void processLCA(){
	memset(P, -1, sizeof(P));
	for (int i=1;i<=n;i++){
		P[0][i] = parent[i];
	}
	for (int j=1;j<=10;j++){
		for (int i=1;i<=n;i++){
			if ( P[j-1][i] != -1 )
				P[j][i] = P[j-1][P[j-1][i]];
		}
	}
}

int getlca(int x, int y){
	if ( level[x] > level[y] ) swap(x, y);

	for (int j=10;j>=0;j--){
		if ( P[j][y] != -1 && level[y] - (1<<j) >= level[x] ) 
			y = P[j][y];
	}
	if ( x == y ) return x;

	for (int j=10;j>=0;j--){
		if (P[j][x] != -1 && P[j][y] != -1 && P[j][x] != P[j][y]){
			x = P[j][x];
			y = P[j][y];
		}
	}
	return parent[x];
}


bool cmp(int i, int j){
	return tin[lca[i]] < tin[lca[j]];
}

void clean(){
	for (int i=1;i<=n;i++) g[i].clear();
	memset(parent, 0, sizeof(parent));
	memset(tin, 0, sizeof(tin));
	timer = 1;
	memset(P, 0, sizeof(P));
	memset(level, 0, sizeof(level));
	memset(p, 0, sizeof(p));
	memset(T, 0, sizeof(T));
	memset(L, 0, sizeof(L));
	memset(R, 0, sizeof(R));
}

bool valid(int pos){
	int a = e[pos].f;
	int b = e[pos].s;
	int LCA = lca[pos];
	return !get(1, 0, timer-1, L[a]) && !get(1, 0, timer-1, L[b]); 
}

void brush(int a){
	update(1, 0, timer-1, L[a], R[a], 1);
}

bool inside(int a, int b){
	return L[b] <= tin[a] && tin[a] <= R[b];
}

void process(int pos){
	int a = e[pos].f;
	int b = e[pos].s;
	int LCA = lca[pos];

	if ( LCA != a ){
		forit(it, g[LCA]){
			int to = *it;
			if ( to == parent[LCA] ) continue;
			if ( inside(a, to) ){
				brush(to);
				break;
			}
		}
	}

	if ( LCA != b){
		forit(it, g[LCA]){
			int to = *it;
			if ( to == parent[LCA] ) continue;
			if ( inside(b, to) ){
				brush(to);
				break;
			}
		}
	}
}


void Solve(){
	scanf("%d", &n);
	clean();

	for (int i=0;i<n-1;i++){
		int a, b;
		scanf("%d%d", &a, &b);
		g[a].pb(b);
		g[b].pb(a);
	}
	dfs(1, -1, 0);
	processLCA();

	scanf("%d", &m);
	for (int i=0;i<m;i++){
		int a, b;
		scanf("%d%d", &a, &b);
		e[i] = mp(a, b);
		lca[i] = getlca(a, b);
	}
	for (int i=0;i<m;i++) p[i] = i;
	sort(p, p + m, cmp);
	reverse(p, p + m);

	int ans = 0;

	for (int i=0;i<m;i++){
		int I = p[i];
		if ( valid(I) ){
			ans++;
			process(I);
		}	
	}
	printf("%d\n", ans);
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	int t;
	scanf("%d", &t);

	for (int i=0;i<t;i++){
		Solve();
	}

	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
