#include <iostream>
#include <string>
#include <cmath>
#include <algorithm>
#include <vector>
#include <cstdio>

using namespace std;

class circle{
public:
    int x, y, r;
    circle() {}
};

vector<string> ans;

string get_ans_string(long long p, long long q, int dir) {
    char tmp[100];
    int d = __gcd(p, q);
    p /= d;
    q /= d;
    if (q == 1)
        sprintf(tmp, "%ll", p);
    else sprintf(tmp, "%ll/%ll", p, q);
    string ans = tmp;
    ans = ans + " " + (dir == 0 ? "clockwise" : "counterclockwise");
    return ans;
}

#define sqr(x) ((x) * (x))

bool check(circle a, circle b) {
    int dist2 = (sqr(a.x - b.x) + sqr(a.y - b.y));
//    cerr << a.x << " " << a.y << " " << b.x << " " << b.y << endl;
//    cerr << dist2 << " " << sqr(a.r + b.r) << endl;
    return (dist2 == sqr(a.r + b.r));
}

void dfs(int v, vector<circle> & a, vector<bool> & used, long long p, long long q, int dir) {
    ans[v] = get_ans_string(p, q, dir);
    used[v] = 1;

    for (int i = 0; i < a.size(); ++i) {
//        cerr << v << ""<< i << ""
        if (!used[i] && check(a[v], a[i])) {
            long long np = p * (a[v].r);
            long long nq = q * (a[i].r);
            dfs(i, a, used, np, nq, 1 - dir);
        }
    }
}

void solve(int n, vector<circle> & a) {
    vector<bool> used(n);
    ans.clear();
    ans.resize(n, "not moving");
    dfs(0, a, used, 1, 1, 0);

    for (int i = 0; i < ans.size(); ++i)
        cout << ans[i] << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    int tests;
    cin >> tests;
    while (tests--) {
        int n;
        cin >> n;
        vector<circle> a(n);
        for (int i = 0; i < n; ++i)
            cin >> a[i].x >> a[i].y >> a[i].r;
        solve(n, a);
    }
    return 0;
}
