#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long int64;

const int kMaxN = 1000000 + 10;
const int kModulo = 1000000000 + 9;
const int kStates = 16, kMaxC = 27;

char x[kMaxN], y[kMaxN], z[kMaxN];
int precalcTable[kMaxC + 1][kMaxC + 1][kMaxC + 1][kStates];
int stateBefore[kStates], stateCurrent[kStates], stateNew[kStates];
int merged[kStates][kStates];

void clearTail(char * s, int n) {
	int m = strlen(s);
	for(int i = m; i <= n; i++)
		s[i] = 0;
}

void add(int & a, int b) {
	a += b;
	if(a >= kModulo) a -= kModulo;
}

int mult(int64 a, int64 b) {
	return (a * b) % kModulo;
}

inline int merge(int a, int b) {
	int c = 0;
	if((a & 1) != 0) c |= (b & 3);
	else c |= (a & 3);
	if((a & 4) != 0) c |= (b & 12);
	else c |= (a & 12);
	return c;
}

void precalc() {
	for(int i = 0; i < kStates; i++)
		for(int j = 0; j < kStates; j++)
			merged[i][j] = merge(i, j);

	for(int i = 0; i < kMaxC; i++) {
		for(int j = 0; j < kMaxC; j++) {
			for(int k = 0; k < kMaxC; k++) {
				int mask = 0;
				if(i < j)
					mask |= 0;
				else if(i == j)
					mask |= 1;
				else if(i > j)
					mask |= 2;
				if(j < k)
					mask |= 0;
				else if(j == k)
					mask |= 4;
				else if(j > k)
					mask |= 8;
				precalcTable[i][j][k][mask] += 1;
				
				if(i != 0)
				precalcTable[kMaxC][j][k][mask] += 1;
				if(j != 0)
				precalcTable[i][kMaxC][k][mask] += 1;
				if(k != 0)
				precalcTable[i][j][kMaxC][mask] += 1;
				
				if(i != 0 && j != 0)
				precalcTable[kMaxC][kMaxC][k][mask] += 1;
				if(j != 0 && k != 0)
				precalcTable[i][kMaxC][kMaxC][mask] += 1;
				if(i != 0 && k != 0)
				precalcTable[kMaxC][j][kMaxC][mask] += 1;
				
				if(i != 0 && j != 0 && k != 0)
				precalcTable[kMaxC][kMaxC][kMaxC][mask] += 1;
			}
		}
	}
}

inline int getCode(char c) { 
	if(c == 0) return 0;
	if(c == '?') return kMaxC;
	return (c - 'a' + 1);
}

void getCurrentState(char a, char b, char c) {
	int i = getCode(a), j = getCode(b), k = getCode(c);
	memcpy(stateCurrent, precalcTable[i][j][k], sizeof(stateCurrent));
}

void solveOne() {
	scanf("%s%s%s", x, y, z);
	int n = max(strlen(x), max(strlen(y), strlen(z)));
	clearTail(x, n);
	clearTail(y, n);
	clearTail(z, n);
	memset(stateBefore, 0, sizeof(stateBefore));
	stateBefore[5] = 1;

	for(int i = 0; i < n; i++) {
		getCurrentState(x[i], y[i], z[i]);
		
		{
			int a = 0;
			for(int b = 0; b < kStates; b++) {
				int c = merged[a][b];
				if(stateBefore[a] != 0 && stateCurrent[b] != 0)
					add(stateNew[c], mult(stateBefore[a], stateCurrent[b]));
			}
		}
		
		{
			int a = 1;
			for(int b = 0; b < kStates; b++) {
				int c = merged[a][b];
				if(stateBefore[a] != 0 && stateCurrent[b] != 0)
					add(stateNew[c], mult(stateBefore[a], stateCurrent[b]));
			}
		}
		
		{
			int a = 4;
			for(int b = 0; b < kStates; b++) {
				int c = merged[a][b];
				if(stateBefore[a] != 0 && stateCurrent[b] != 0)
					add(stateNew[c], mult(stateBefore[a], stateCurrent[b]));
			}
		}
		
		{
			int a = 5;
			for(int b = 0; b < kStates; b++) {
				int c = merged[a][b];
				if(stateBefore[a] != 0 && stateCurrent[b] != 0)
					add(stateNew[c], mult(stateBefore[a], stateCurrent[b]));
			}
		}
		
		memcpy(stateBefore, stateNew, sizeof(stateNew));
		memset(stateCurrent, 0, sizeof(stateCurrent));
		memset(stateNew, 0, sizeof(stateNew));
	}
	
	int result = stateBefore[0];
	printf("%d\n", result);
}

int main() {
	precalc();
	int tests;
	scanf("%d", &tests);
	while(tests--) solveOne();
	return 0;
}