#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int gcd(int a, int b)
{
	if(b == 0)
		return a;
	return gcd(b, a % b);
}

#define CLOCKWISE 0
#define COUNTERCLOCKWISE 1

struct Wheel
{
	int x, y, r;
	int p, q;
	bool dir;

	Wheel():x(0),y(0),r(0),p(0),q(1),dir(CLOCKWISE){}
};

void solve()
{
	int n;
	cin >> n;
	vector<Wheel> wheels(n+1);
	for(int i = 1; i <= n; i++)
	{
		cin >> wheels[i].x >> wheels[i].y >> wheels[i].r;
	}
	wheels[1].p = 1;
	queue<int> q;
	q.push(1);
	while(!q.empty())
	{
		int w = q.front();
		int g = gcd(wheels[w].p, wheels[w].q);
		wheels[w].p /= g;
		wheels[w].q /= g;
		q.pop();
		for(size_t i = 2; i < wheels.size(); i++)
		{
			if(wheels[i].p == 0)
			{
				//cerr << "lolka " << i << endl;
				//cerr << ((wheels[w].x - wheels[i].x)*(wheels[w].x - wheels[i].x) + (wheels[w].y - wheels[i].y)*(wheels[w].y - wheels[i].y)) << " == " << ((wheels[w].r + wheels[i].r)*(wheels[w].r + wheels[i].r)) << endl;
				if(((wheels[w].x - wheels[i].x)*(wheels[w].x - wheels[i].x) + (wheels[w].y - wheels[i].y)*(wheels[w].y - wheels[i].y)) == ((wheels[w].r + wheels[i].r)*(wheels[w].r + wheels[i].r)) )
				{
					wheels[i].p = wheels[w].p * wheels[w].r;
					wheels[i].q = wheels[w].q * wheels[i].r;
					wheels[i].dir = !wheels[w].dir;
					q.push(i);
				}
			}
		}
	}
	for(size_t i = 1; i < wheels.size(); i++)
	{
		if(wheels[i].p == 0)
		{
			cout << "not moving\n";
			continue;
		}
		cout << wheels[i].p;
		if(wheels[i].q != 1)
			cout << '/' << wheels[i].q;
		if(wheels[i].dir)
			cout << " counterclockwise\n";
		else
			cout << " clockwise\n";
	}
}

int main()
{
	int t;
	cin >> t;
	for(int i = 0; i < t; i++)
		solve();
	//cin >> t;
	return 0;
}