#include <iostream>
#include <vector>

using namespace std;

#define WHITE 0
#define BLACK 1

struct BrickBlock
{
	int cnt;
	bool type;
	int prefix_bcnt, prefix_wcnt;
};

int gcd(long long a, long long b)
{
	if(b == 0)
		return a;
	return gcd(b, a % b);
}

inline int cmp(long long a, long long b, long long p, long long q) // a/b == p/q
{
	if(b != 0 && q != 0)
	{
		int gcd1 = gcd(a, b), gcd2 = gcd(p, q);
		a /= gcd1; b /= gcd1;
		p /= gcd2; q /= gcd2;
		//double ratio1 = (double)a / b, ratio2 = (double)p / q;
		if(a == p && b == q)
			return 0;
		else if(a*q < p*b)
			return -1;
		else
			return 1;
	}
	else if(b == 0 && q != 0)
	{
		return 1;
	}
	else if(b != 0 && q == 0)
	{
		return -1;
	}
	else
	{
		return 0;
	}
}

void solve()
{
	int n;
	cin >> n;
	int bcnt = 0, wcnt = 0;
	vector<BrickBlock> bricks(n);
	int tmpcnt;
	char brick;
	for(int i = 0; i < n; i++)
	{
		cin >> tmpcnt >> brick;
		bricks[i].cnt = tmpcnt;
		if(brick == 'W')
		{
			wcnt += tmpcnt;
			bricks[i].type = WHITE;
		}
		else
		{
			bcnt += tmpcnt;
			bricks[i].type = BLACK;
		}
		bricks[i].prefix_bcnt = bcnt;
		bricks[i].prefix_wcnt = wcnt;
	}
	if(bcnt == 0)
	{
		cout << wcnt << endl;
		return;
	}
	if(wcnt == 0)
	{
		cout << bcnt << endl;
		return;
	}
	int prev_prefix_bcnt = bricks[0].prefix_bcnt;
	int prev_prefix_wcnt = bricks[0].prefix_wcnt;
	int ans = 0;
	for(int i = 1; i < n; i++)
	{
		if(cmp(prev_prefix_wcnt, prev_prefix_bcnt, wcnt, bcnt) != cmp(bricks[i].prefix_wcnt, bricks[i].prefix_bcnt, wcnt, bcnt))
		{
			//cerr << "change in " << i << endl;
			if(cmp(prev_prefix_wcnt, prev_prefix_bcnt, wcnt, bcnt) == 0)
			{
				//cerr << "i am in " << i << endl;
				prev_prefix_wcnt = bricks[i].prefix_wcnt;
				prev_prefix_bcnt = bricks[i].prefix_bcnt;
				continue;
			}
			//cerr << "in block " << i << "found ratio\n";
			ans++;
			prev_prefix_wcnt = bricks[i].prefix_wcnt;
			prev_prefix_bcnt = bricks[i].prefix_bcnt;
		}
	}
	cout << ans << endl;
}

int main()
{
	int t;
	cin >> t;
	for(int i = 0; i < t; i++)
		solve();
	//cin >> t;
}