#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

const int BLACK = 0;
const int WHITE = 1;

int gcd(int a, int b) {
    return a == 0 ? b : gcd(b % a, a);
}


int main() {
    ios_base::sync_with_stdio(false);
    int tests;
    cin >> tests;
    for (int test = 0; test < tests; ++test) {
        int n;
        cin >> n;
        vector <pair <long long, int> > input(n);
        long long cnt_b = 0, cnt_w = 0;
        for (int i = 0; i < n; ++i) {
            char c;
            cin >> input[i].first >> c;
            if (c == 'B') {
                input[i].second = BLACK;
                cnt_b += input[i].first;
            } else {
                input[i].second = WHITE;
                cnt_w += input[i].first;
            }
        }

        if (cnt_b == 0) {
            cout << cnt_w << endl;
            continue;
        } else if (cnt_w == 0) {
            cout << cnt_b << endl;
            continue;
        }

        long long g = gcd(cnt_b, cnt_w);
        cnt_b /= g;
        cnt_w /= g;

        long long cur_b = 0, cur_w = 0;
        long long ans = 0;

        for (int i = 0; i < n; ++i) {
            if (input[i].second == BLACK) {
                if (cur_w % cnt_w != 0) {
                    cur_b += input[i].first;
                } else {
                    long long need = cur_w / cnt_w;
                    need *= cnt_b;
                    cur_b += input[i].first;
                    if (need <= cur_b && need != 0) {
                        ++ans;
                        cur_b -= need;
                        cur_w = 0;
                    }
                }
            } else {
                if (cur_b % cnt_b != 0) {
                    cur_w += input[i].first;
                } else {
                    long long need = cur_b / cnt_b;
                    need *= cnt_w;
                    cur_w += input[i].first;
                    if (need <= cur_w && need != 0) {
                        ++ans;
                        cur_w -= need;
                        cur_b = 0;
                    }
                }

            }
        }
        if (cur_w != 0 || cur_b != 0)
            ++ans;
        cout << ans << '\n';
    }
    return 0;
}
