#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

int timerR = 0;
void precalc();
void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;
	precalc();

	int t = 1;
	cin >> t;
	while(t--) {
		//++timerR;
	//cout << "Case #" << timerR << ": ";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int minBit[1 << 11];

void precalc() {
	for (int mask = 0; mask < (1 << 11); ++mask)
		for (int i = 0; i < 11; ++i)
			if (!(mask & (1 << i))) {
				minBit[mask] = i;
				break;
			}
}

int n;

const int L = 11;

vector<int> g[1011];
int parent[1011][L];

int tin[1011], tout[1011];

int TIMER = 1;

void dfs1(int v, int p = 0) {
	tin[v] = TIMER++;
	parent[v][0] = p;
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (to == p)
			continue;
		dfs1(to, v);
	}
	tout[v] = TIMER++;
}

bool upper (int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
	if (upper(a, b))
		return a;
	for (int j = L - 1; j >= 0; --j)
		if (!upper(parent[a][j], b))
			a = parent[a][j];
	return parent[a][0];
}

struct path {
	int a;
	int b;
	int Lca;
	int firstSon, secondSon;
	path(int a, int b, int Lca, int firstSon, int secondSon):a(a), b(b), Lca(Lca), firstSon(firstSon), secondSon(secondSon) {}
};

vector<path> paths[1011];

int getNext(int v, int need) {
	if (v == need)
		return v;
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (tin[to] < tin[v])
			continue;
		if (upper(to, need))
			return to;
	}
	assert(false);
}

int dp[1011][1011];

void dfs2(int v, int p = -1) {
	vector<int> have;
	int sumMx = 0;
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (to == p)
			continue;
		dfs2(to, v);
		have.push_back(to);
		sumMx += dp[to][to];
	}
	sort(all(have));

	vector<int> taken;
	vector<pair<int, int>> pairs;
	for (int i = 0; i < paths[v].size(); ++i) {
		path cur = paths[v][i];
		if (cur.firstSon == v) {
			taken.push_back(cur.secondSon);
			continue;
		}
		if (cur.secondSon == v) {
			taken.push_back(cur.firstSon);
			continue;
		}
		int add = dp[cur.firstSon][cur.a] + dp[cur.secondSon][cur.b] + 1 - dp[cur.firstSon][cur.firstSon] - dp[cur.secondSon][cur.secondSon];
		if (add <= 0)
			continue;
		pairs.push_back(mp(cur.firstSon, cur.secondSon));
	}

	for (int i = 0; i < taken.size(); ++i)
		taken[i] = lower_bound(all(have), taken[i]) - have.begin();
	for (int i = 0; i < pairs.size(); ++i) {
		pairs[i].first = lower_bound(all(have), pairs[i].first) - have.begin();
		pairs[i].second = lower_bound(all(have), pairs[i].second) - have.begin();
		if (pairs[i].first > pairs[i].second)
			swap(pairs[i].first, pairs[i].second);
	}

	sort(all(taken));
	taken.erase(unique(all(taken)), taken.end());
	sort(all(pairs));
	pairs.erase(unique(all(pairs)), pairs.end());

	vector<int> dpIn(1 << (have.size()));

	int initial = 0;
	for (int i = 0; i < taken.size(); ++i)
		initial |= (1 << taken[i]);

	dpIn[initial] = taken.size();

	for (int mask = initial; mask < (1 << have.size()); ++mask) {
		if ((mask & initial) != initial)
			continue;

		for (int i = 0; i < pairs.size(); ++i) {
			if (!(mask & (1 << pairs[i].first)) && !(mask & (1 << pairs[i].second))) {
				dpIn[mask | (1 << pairs[i].first) | (1 << pairs[i].second)] = max(dpIn[mask | (1 << pairs[i].first) | (1 << pairs[i].second)], dpIn[mask] + 1);
			}
		}
	}

	for (int mask = initial; mask < (1 << have.size()); ++mask) {
		if ((mask & initial) != initial)
			continue;
		int cur = minBit[mask];
		if (cur < have.size())
			dpIn[mask | (1 << cur)] = max(dpIn[mask | (1 << cur)], dpIn[mask]);
	}

	for (int i = 0; i < have.size(); ++i) {
		if (initial & (1 << i)) {
		}
		else {
			int mask = ((1 << have.size()) - 1) ^ (1 << i);
			for (int u = 0; u < n; ++u)
				if (upper(have[i], u))
					dp[v][u] = dp[have[i]][u] + sumMx - dp[have[i]][have[i]] + dpIn[mask];
		}
	}
	dp[v][v] = dpIn[(1 << have.size()) - 1] + sumMx;
}

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		g[i].clear();
		paths[i].clear();
	}

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			dp[i][j] = 0;

	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	dfs1(0);
	for (int j = 1; j < L; ++j)
		for (int i = 0; i < n; ++i)
			parent[i][j] = parent[parent[i][j - 1]][j - 1];

	int m;
	cin >> m;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		int Lca = lca(u, v);
		int firstSon = getNext(Lca, u), secondSon = getNext(Lca, v);
		paths[Lca].push_back(path(u, v, Lca, firstSon, secondSon));
	}

	dfs2(0);

	cout << dp[0][0] << "\n";

	
}