#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

int timerR = 0;

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	//cout.sync_with_stdio(0);
	//cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		//++timerR;
	//cout << "Case #" << timerR << ": ";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int n, m;

int TIMER = 0;
int par[1100];

int getAnc(int x) {
	if (par[x] == x) {
		return x;
	}
	return par[x] = getAnc(par[x]);
}

void uni(int x, int y) {
	if (rand() & 1) {
		par[x] = par[y];
	}
	else {
		par[y] = par[x];
	}
}



struct edge {
	int x, y;
	int w;
	edge(){}
	edge(int x, int y, int w):x(x),y(y),w(w){}
	bool operator < (const edge& oth) const {
		return w < oth.w;
	}
};

vector <edge> edges;

int mstLen[101000];
int prefsums[101000][1010];


pair <int, int> con;

int get() {
	if (edges.empty()) {
		return 0;
	}

	if (edges.back().w < con.first) {
		return 0;
	}

	int id = lower_bound(edges.begin(), edges.end(), edge(0,0,con.first)) - edges.begin();

	int l = 0;
	int r = mstLen[id] + 1;

	while (l + 1 < r) {
		int m = (l + r) / 2;
		if (prefsums[id][m] - prefsums[id][m - 1] > con.second) {
			r = m;
		}
		else {
			l = m;
		}
	}
	return prefsums[id][l];
}

void solve() {
	scanf("%d %d", &n, &m);
	edges.clear();
	//edges.resize(m);

	for (int i = 0; i < m; ++i) {
		int x, y, w;
		scanf("%d %d %d", &x, &y, &w);
		--x;
		--y;
		edges.push_back(edge(x, y, w));
	}

	sort(edges.begin(), edges.end());

	vector <int> curMst[2];
	int curId = 0;

	for (int i = edges.size() - 1; i >= 0; --i) {
		curMst[curId].push_back(i);
		curMst[!curId].clear();

		for (int j = 0; j < n; ++j) {
			par[j] = j;
		}

		for (int j = curMst[curId].size() - 1; j >= 0; --j) {
			int edId = curMst[curId][j];
			int xx = getAnc(edges[edId].x);
			int yy = getAnc(edges[edId].y);
			if (xx == yy) {
				continue;
			}
			uni(xx, yy);

			curMst[!curId].push_back(edId);
		}

		mstLen[i] = curMst[!curId].size();
		for (int j = 0; j < curMst[!curId].size(); ++j) {
			int edId = curMst[!curId][j];
			prefsums[i][j + 1] = prefsums[i][j] + edges[edId].w;
		}

		reverse(curMst[!curId].begin(), curMst[!curId].end());
		curId = !curId;
	}


	int q;
	cin >> q;

	int ans = 0;
	for (int qq = 0; qq < q; ++qq) {
		
		scanf("%d %d", &con.first, &con.second);
		
		con.first -= ans;
		con.second -= ans;

		ans = get();
		printf("%d\n", ans);
	}
}