#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>

using namespace std;

struct rational
{
	long long x, y;
	rational(long long a, long long b) 
	{
		long long t = __gcd(a, b);
		a /= t, b /= t;
		x = a, y = b;
	}
	rational(){}
	
} d[1111];

vector<int> vec[1111];
int color[1111], x[1111], r[1111], y[1111];

rational operator * (rational a, rational b)
{
	return rational(a.x * b.x, a.y*b.y);
}


void dfs(int v)
{
	for(int i = 0; i < vec[v].size(); i++)
	{
		if ((d[vec[v][i]].x == -1))
		{
			d[vec[v][i]] = rational(r[v], r[vec[v][i]]) * d[v];
			color[vec[v][i]] = color[v] ^ 1;
			dfs(vec[v][i]);
		}
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	int tests;
	cin >> tests;
	for(int qwe = 0; qwe < tests; qwe++)
	{
		int n;
		cin >> n;
		for(int i = 0; i < n; i++)
		{
			cin >> x[i] >> y[i] >> r[i];
			vec[i].clear();
			d[i].x = -1;
		}
		d[0] = 1;
		for(int i = 0; i < n; i++)
		{
			for(int j = i + 1; j < n; j++)
			{
				if (abs(y[i] - y[j])*abs(y[i] - y[j]) + abs(x[i] - x[j])*abs(x[i] - x[j]) == (r[i] + r[j]) * (r[i] + r[j]))
				{
					vec[i].push_back(j);
					vec[j].push_back(i);
				}
			}
		}
		color[0] = 0;
		dfs(0);
		for(int i = 0; i < n; i++)
		{
			if (d[i].x == -1)
			{
				cout << "not moving" << endl;
			} else {
				if (d[i].y == 1)
				{
					cout << d[i].x;
				} else {
					cout << d[i].x << "/" << d[i].y;
				}
				if (color[i])
				{
					cout << " counterclockwise" << endl;
				} else {
					cout << " clockwise" << endl;
				}
			}
		}	
	}
    return 0;
}
