#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int mxrms = (1 << 19) - 1;
const int size = 200 * 1000 + 100;

int tc;
int x[size], y[size];
vector <int> convex[mxrms + 1];
int rms, hrms;
int n;

long long vmult(int a, int b, int c, int d) {
	return (x[b] - x[a]) * 1ll * (y[d] - y[c]) - (y[b] - y[a]) * 1ll * (x[d] - x[c]);
}

bool could(int a, int b, int v) {
	if (convex[v].empty())
		return false;
	int lb = 0;
	int rb = (int) convex[v].size() - 1;
	while (lb < rb) {
		int mid = (lb + rb) / 2;
		if (vmult(a, b, convex[v][mid], convex[v][mid + 1]) >= 0)
			lb = mid + 1;
		else
			rb = mid;
	}

	return vmult(a, b, a, convex[v][lb]) > 0;
}

bool flag;
int curv;
int curp;

void rss(int v, int lb, int rb, int i, int j) {
	if (lb > j || rb < i)
		return;
	if (flag)
		return;
	if (lb >= i && rb <= j) {
		if (could(curp, curp + 1, v)) {
			flag = true;
			curv = v;
		}

		return;
	}

	rss(v * 2, lb, (lb + rb) / 2, i, j);
	rss(v * 2 + 1, (lb + rb) / 2 + 1, rb, i, j);
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));

	scanf("%d", &tc);
	for (int tnum = 0; tnum < tc; tnum++) {
		scanf("%d", &n);

		for (int i = 0; i < n; i++)
			scanf("%d%d", &x[i], &y[i]);

		rms = 1;
		while (rms < n)
			rms *= 2;
		rms *= 2;
		rms--;
		hrms = rms / 2;
	
		for (int i = 0; i <= rms; i++)
			convex[i].clear();
		for (int i = 0; i < n; i++)
			convex[hrms + 1 + i].pb(i);
		for (int i = hrms; i > 0; i--) {
			convex[i] = convex[i * 2];
			for (int j = 0; j < (int) convex[i * 2 + 1].size(); j++) {
				while (convex[i].size() > 1u && vmult(convex[i][(int) convex[i].size() - 2], convex[i].back(), convex[i].back(), convex[i * 2 + 1][j]) > 0) {
					convex[i].pop_back();
				}
				convex[i].pb(convex[i * 2 + 1][j]);
			}
		}

		for (int i = 0; i < n - 2; i++) {
			curp = i;
			flag = false;
			rss(1, 1, hrms + 1, i + 3, n);
			if (!flag) {
				printf("0 ");
			} else {
				while (curv <= hrms) {
					if (could(curp, curp + 1, curv * 2))
						curv *= 2;
					else
						curv = curv * 2 + 1;
				}

				printf("%d ", curv - hrms - 1);
			}
		}
		printf("0\n");
	}

	return 0;
}