#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int size = 1000 + 100;
const int iters = 20;
const int inf = 1000 * 1000 * 1000;
const int H = 2;
const int64 P[H] = {17239, 23917};
const int64 M = (int) 1e9 + 7;
const int64 M2 = M * M;
int h[H][size], ppow[H][size];

char buf[size];
int tc;
int base[size];
int n;
int ts;
int suflink[size];
int way[size][4];
int len[size];
int str[size];
int mg[256];
int cur;
int ans[size];
int64 myhash[size];
map <int64, int> hashes;

vector <int> vertex[size];

void init() {
	ts = 2;
	suflink[0] = -1;
	suflink[1] = 0;
	len[0] = -1;
	len[1] = 0;
	myhash[0] = 0;
	myhash[1] = 0;
	hashes[0] = 1;
	for (int i = 0; i < 4; i++)
		way[0][i] = way[1][i] = 0;
	cur = 0;
}

int get_h(int ih, int i, int len) {
	return (h[ih][i + len] - h[ih][i] * (int64) ppow[ih][len] + M2) % M;
}

int64 get(int i, int len) {
	return get_h(0, i, len) * (int64) M + get_h(1, i, len);
}

void calc_h(int * s, int n) {
	for (int ih = 0; ih < H; ++ih) {
		h[ih][0] = 0, ppow[ih][0] = 1;
		for (int i = 0; i < n; ++i) {
			h[ih][i + 1] = (h[ih][i] * (int64) P + s[i] +   1) % M;
			ppow[ih][i + 1] = (ppow[ih][i] * (int64) P) % M;
		}
	}
}

int main() {
	mg['A'] = 0;
	mg['G'] = 1;
	mg['T'] = 2;
	mg['C'] = 3;

	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	
	scanf("%d", &tc);

	for (int tnum = 0; tnum < tc; tnum++) {
		scanf("%s", buf);
	
		hashes.clear();
		n = strlen(buf);
		for (int i = 0; i < n; i++)
			str[i] = mg[buf[i]];

		init();
		calc_h(str, n);
		for (int i = 0; i < n; i++) {
			while (i - 1 - len[cur] < 0 || str[i] != str[i - 1 - len[cur]])
				cur = suflink[cur];
			if (way[cur][str[i]] != 0) {
				cur = way[cur][str[i]];
			} else {
				for (int j = 0; j < 4; j++)
					way[ts][j] = 0;
				way[cur][str[i]] = ts;
				len[ts] = len[cur] + 2;
				int h = suflink[cur];
				while (h != -1 && (str[i] != str[i - 1 - len[h]] || way[h][str[i]] == 0))
					h = suflink[h];
				if (h == -1)
					suflink[ts] = 1;
				else
					suflink[ts] = way[h][str[i]];
				cur = ts;
				ts++;

				vertex[cur].pb(0);
				vertex[cur].pb(1);
				myhash[cur] = get(i - len[cur] + 1, len[cur]);
				hashes[myhash[cur]] = cur;
			}
		}

		base[0] = (n >= 2 && str[0] == str[1]);
		int b = 0;
		for (int i = 0; i < n; i++) {
			if (b + base[b] > i) {
				base[i] = min(b + base[b] - i, base[b - (i - b)]);
			} else {
				base[i] = 0;
			}
			int h = min(base[i], i - b);
			int from = hashes[get(b - base[b] + 1, base[b] * 2)];
			int to = hashes[get(i - h + 1, 2 * h)];
			vertex[from].pb(to);

			while (i - base[i] >= 0 && i + base[i] + 1 < n && str[i - base[i]] == str[i + 1 + base[i]])
				base[i]++;
			if (i + base[i] > b + base[b])
				b = i;
		}

		for (int i = 0; i < ts; i++) {
			ans[i] = max(len[i], 0);
		}

		for (int it = 0; it < iters; it++) {
			for (int i = 0; i < ts; i++) {
				if (len[i] % 2 == 0)
					for (int j = 0; j < (int) vertex[i].size(); j++)
						ans[i] = min(ans[i], len[i] / 2 + 1 - len[vertex[i][j]] + ans[vertex[i][j]]);
			}
		}

		int rans = inf;
		for (int i = 0; i < ts; i++)
			if (len[i] % 2 == 0)
				rans = min(rans, n - len[i] + ans[i]);

		printf("%d\n", rans);
	}

	return 0;
}