#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 1000500;
const int MOD = 1000000009;

int pows26[3 * MAXN];
int cnt[27][27][27];
int sum[3][MAXN];
int d1[MAXN], d2[MAXN], com[MAXN];
char str[3][MAXN];
int len[3];

void
precalc()
{
	for (int i = 0; i < 27; ++i) {
		for (int j = 0; j < 27; ++j) {
			for (int k = 0; k < 27; ++k) {
				cnt[i][j][k] = 0;
			}
		}
	}
	for (int i = 0; i < 26; ++i) {
		for (int j = 0; j < 26; ++j) {
			for (int k = 0; k < 26; ++k) {
				if (i < j && j < k) {
					cnt[i][j][k]++;
					cnt[i][j][26]++;
					cnt[i][26][k]++;
					cnt[i][26][26]++;
					cnt[26][j][k]++;
					cnt[26][j][26]++;
					cnt[26][26][k]++;
					cnt[26][26][26]++;
				}
			}
		}
	}
	pows26[0] = 1;
	for (int i = 1; i < 3 * MAXN; ++i) {
		pows26[i] = 1ll * pows26[i - 1] * 26 % MOD;
	}
}

void
add(int &dst, int src)
{
	dst += src;
	while (dst >= MOD) {
		dst -= MOD;
	}
}

void
calcD(int *d, int f, int s, int len)
{
	d[len] = 0;
	for (int pos = len - 1; pos >= 0; --pos) {
		if (str[f][pos] != '?') {
			if (str[s][pos] != '?') {
				if (str[f][pos] == str[s][pos]) {
					d[pos] = d[pos + 1];
				} else if (str[f][pos] > str[s][pos]) {
					d[pos] = 0;
				} else {
					d[pos] = pows26[sum[f][pos + 1] + sum[s][pos + 1]];
				}
			} else {
				d[pos] = 1ll * pows26[sum[f][pos + 1] + sum[s][pos + 1]] * ('z' - str[f][pos]) % MOD;
				if (str[f][pos] != 'a' - 1) {
					add(d[pos], d[pos + 1]);
				}
			}
		} else if (str[s][pos] != '?') {
			d[pos] = 1ll * pows26[sum[f][pos + 1] + sum[s][pos + 1]] * max(0, str[s][pos] - 'a') % MOD;
			if (str[s][pos] != 'a' - 1) {
				add(d[pos], d[pos + 1]);
			}
		} else {
			d[pos] = 1ll * pows26[sum[f][pos + 1] + sum[s][pos + 1]] * (13 * 25) % MOD;
			add(d[pos], 1ll * d[pos + 1] * 26 % MOD);
		}
	}
}

bool
check(char a, char b)
{
	return (a == '?' || a == b || b == '?');
}

void
process()
{
	for (int i = 0; i < 3; ++i) {
		scanf(" %s", str[i]);
		len[i] = strlen(str[i]);
	}
	// calc d1
	int m = *max_element(len, len + 3) + 1;
	for (int i = 0; i < 3; ++i) {
		for (int j = len[i]; j < m; ++j) {
			str[i][j] = 'a' - 1;
		}
	}
	for (int i = 0; i < 3; ++i) {
		sum[i][m] = 0;
		for (int j = m - 1; j >= 0; --j) {
			sum[i][j] = sum[i][j + 1] + (str[i][j] == '?');
		}
	}
	// calc d1 and d2
	calcD(d1, 0, 1, m);
	calcD(d2, 1, 2, m);
	// calc common
	com[0] = 1;
	for (int i = 1; i <= m; ++i) {
		int cnt = 0, cnt1 = 0;
		char c = '?';
		for (int id = 0; id < 3; ++id) {
			if (str[id][i - 1] == '?') {
				++cnt;
			} else if (str[id][i - 1] == 'a' - 1) {
				++cnt1;
			} else {
				c = str[id][i - 1];
			}
		}
		if (cnt1 != 0) {			
			com[i] = 0;
		} else if (cnt == 3) {
			com[i] = 26ll * com[i - 1] % MOD;
		} else if (check(str[0][i - 1], c) &&
			check(str[1][i - 1], c) &&
			check(str[2][i - 1], c)) {
				com[i] = com[i - 1];
		} else {
			com[i] = 0;
		}
	}
	int res = 0;
	for (int comCount = 0; comCount < m; ++comCount) {
		int m1 = com[comCount];
		if (!m1) {
			continue;
		}
		// all unequal
		int a = (str[0][comCount] == '?') ? 26 : str[0][comCount] - 'a';
		int b = (str[1][comCount] == '?') ? 26 : str[1][comCount] - 'a';
		int c = (str[2][comCount] == '?') ? 26 : str[2][comCount] - 'a';
		int m2 = 1ll * cnt[a][b][c] * pows26[sum[0][comCount + 1] + sum[1][comCount + 1] + sum[2][comCount + 1]] % MOD;
		add(res, 1ll * m1 * m2 % MOD);
		// first two equal
		for (char curC = 'a'; curC <= 'z'; ++curC) {
			if (!check(curC, str[0][comCount]) || !check(curC, str[1][comCount])
				|| (str[2][comCount] != '?' && curC >= str[2][comCount])) {
					continue;
			}
			int pow1 = (str[2][comCount] != '?') ? 1 : 'z' - curC;
			add(res, 1ll * m1 * pow1 % MOD * pows26[sum[2][comCount + 1]] % MOD * d1[comCount + 1] % MOD);
		}
		// second two equal
		for (char curC = 'a'; curC <= 'z'; ++curC) {
			if (!check(curC, str[1][comCount]) || !check(curC, str[2][comCount])
				|| (str[0][comCount] != '?' && curC <= str[0][comCount])) {
					continue;
			}
			int pow1 = (str[0][comCount] != '?') ? 1 : curC - 'a';
			add(res, 1ll * m1 * pow1 % MOD * pows26[sum[0][comCount + 1]] % MOD * d2[comCount + 1] % MOD);
		}
	}
	printf("%d\n", res);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	precalc();
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process();
	}
	
	//printf("%d %d", int('?'), int('a' - 1));
	return 0;
}