#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 333;

int n, step = 0;
int a[N], b[N], c[N];
int x[2 * N];
int used[2 * N][2 * N], d[2 * N][2 * N];

int calc(int l, int r) {
	if (l > r) {
		return 0;
	}
	if (used[l][r] == step) {
		return d[l][r];
	}
	used[l][r] = step;
	d[l][r] = inf;
	pii best(-1, -1);
	for (int i = 0; i < n; ++i) {
		if (a[i] >= l && b[i] <= r) {
			best = max(best, mp(c[i], i));
		}
	}
	if (best.sc == -1) {
		return d[l][r] = 0;
	}
	for (int i = a[best.sc]; i <= b[best.sc]; ++i) {
		d[l][r] = min(d[l][r], calc(l, i - 1) + calc(i + 1, r) + best.fs);
	}
	return d[l][r];
}

inline void solve() {
	scanf("%d", &n);
	int sz = 0;
	for (int i = 0; i < n; ++i) {
		scanf("%d %d %d", &a[i], &b[i], &c[i]);
		x[sz++] = a[i];
		x[sz++] = b[i];
	}
	sort(x, x + sz);
	sz = unique(x, x + sz) - x;
	for (int i = 0; i < n; ++i) {
		a[i] = lower_bound(x, x + sz, a[i]) - x;
		b[i] = lower_bound(x, x + sz, b[i]) - x;
	}
	++step;
	for (int i = sz - 1; i >= 0; --i) {
		for (int j = i; j < sz; ++j) {
			calc(i, j);
		}
	}
	printf("%d\n", calc(0, sz - 1));
}

int main() {
#ifdef LOCAL42
#define TASK "L"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
