#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

int n, k;
const int MAXN = 262144;
pii items[MAXN];
int least[MAXN][16];
int nleast[MAXN];
int used[MAXN];
int first[1048576];

bool canwin(int v, int k) {
  if (v <= 0) return true;
  if (k <= 0) return true;
  int i = first[v];
  if (i < 0) return false;
  for (int p = 0, t = 0; p < nleast[i] && t < k; p++) {
    int u = least[i][p];
    if (used[u]) continue;
    used[u] = 1;
    if (canwin(v + items[u].second, k - 1)) return true;
    used[u] = 0;
    t++;
  }
  return false;
}

bool scompare(int a, int b) {
  return items[a].second < items[b].second;
}

void test() {
  scanf("%d%d", &n, &k);
  FOR(i, 0, n) scanf("%d%d", &items[i].first, &items[i].second), items[i].first -= items[i].second;
  sort(items, items + n);
  nleast[n] = 0;
  FOR(i, 0, 1048576) first[i] = -1;
  ROF(i, 0, n) {
    if (items[i].first >= 0) {
      first[items[i].first] = i;
    }
    nleast[i] = nleast[i + 1];
    FOR(j, 0, nleast[i]) least[i][j] = least[i + 1][j];
    least[i][nleast[i]++] = i;
    sort(least[i], least[i] + nleast[i], scompare);
    nleast[i] = min(nleast[i], 10);
  }
  ROF(i, 0, 1048575) if (first[i] < 0) first[i] = first[i + 1];
  int left = 0;
  int right = 1000000;
  while (left < right) {
    int mid = (left + right + 1) / 2;
    FOR(i, 0, n) used[i] = 0;
    if (canwin(mid, k + 1)) {
      left = mid;
    } else {
      right = mid - 1;
    }
  }
  printf("%d\n", left);
}

int main() {
  int T;
  scanf("%d", &T);
  FOR(i, 0, T) test();
  return 0;
}
