#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

const int N = 1000;

vector <int> E[N];
int color[N];
bool used[N];

struct circle{
	ll x, y, r;
	void scan()
	{
		scanf("%lld %lld %lld", &x, &y, &r);
	}

};

ll gcd(ll a, ll b)
{
	if (b == 0) return a;
	return gcd(b, a % b);
}

struct fraction
{
	ll p, q;
	fraction() : p(0), q(1) {}
	fraction(ll p, ll q) : p(p), q(q) {}
	fraction operator *(fraction &v)
	{
		ll new_p = p * v.p;
		ll new_q = q * v.q;
		ll g = gcd(new_p, new_q);
		return fraction(new_p / g, new_q / g);
	}
	void print()
	{
		cout << p;
		if (q != 1)
		{
			cout << "/" << q;
		}
	}
};

circle cs[N];

fraction ans[N];

void dfs(int v, int c)
{
	used[v] = true;

	color[v] = c;
	for (int i = 0; i < E[v].size(); i++)
	{
		int to = E[v][i];
		if (!used[to])
		{
			ans[to] = ans[v] * fraction(cs[v].r, cs[to].r);
			dfs(to, c^1);
		}
	}
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

	int tests;
	cin >> tests;
	for (int q = 0; q < tests; q++)
	{
		ans[0] = fraction(1, 1);
		ll n;
		cin >> n;
		
		NEGATE(color);
		ZERO(used);
		for (int i = 0; i < N; i++)
			E[i].clear();

		for (int i = 0; i < n; i++)
		{
			cs[i].scan();
		}

		for (int i = 0; i < n; i++)
		{
			for (int j = i + 1; j < n; j++)
			{
				if ( (cs[i].r + cs[j].r)*(cs[i].r + cs[j].r) == ((cs[i].x - cs[j].x)*(cs[i].x - cs[j].x) + (cs[i].y - cs[j].y)*(cs[i].y - cs[j].y)) )
				{
					E[i].push_back(j);
					E[j].push_back(i);
				}
			}
		}

		dfs(0, 0);

		for (int i = 0; i < n; i++)
		{
			if (color[i] == 0)
			{
				ans[i].print();
				cout << " ";
				cout << "clockwise" << endl;
				continue;
			}
			if (color[i] == 1)
			{
				ans[i].print();
				cout << " ";
				cout << "counterclockwise" << endl;
				continue;
			}

			cout << "not moving" << endl;
		}
	}

    return 0;
}