#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

ll gcd(ll a, ll b)
{
	if (b == 0) return a;
	return gcd(b, a % b);
}

const int MAX_N = 100050;

int n;
ll white_total;
ll black_total;

ll white_ratio;
ll black_ratio;

pair<ll, char> seq[MAX_N];
int seq_len;

void read_input()
{
	cin >> n;
	white_total = 0;
	black_total = 0;
	ZERO(seq);
	seq_len = -1;

	for (int i = 0; i < n; ++i)
	{
		ll k;
		cin >> k;
		char col;
		cin >> col;

		if (col == 'B')
		{
			black_total += k;
		}
		else
		{
			white_total += k;
		}

		if (seq_len != -1 && seq[seq_len].second == col)
		{
			seq[seq_len].first += k;
		}
		else
		{
			seq[++seq_len].first = k;
			seq[seq_len].second = col;
		}
	}
	++seq_len;

	if (black_total == 0)
	{
		black_ratio = 0;
		white_ratio = 1;
	}
	else if (white_total == 0)
	{
		white_ratio = 0;
		black_ratio = 1;
	}
	else
	{
		ll gc = gcd(white_total, black_total);
		white_ratio = white_total / gc;
		black_ratio = black_total / gc;
	}
}

int solve()
{
	if (white_ratio == 0)
	{
		return black_total;
	}
	if (black_ratio == 0)
	{
		return white_total;
	}

	ll W = white_ratio;
	ll B = black_ratio;

	ll w = 0;
	ll b = 0;

	if (seq[0].second == 'W')
	{
		w += seq[0].first;
	}
	else 
	{
		b += seq[0].first;
	}

	ll ans = 0;
	int pos = 1;
	while (pos < seq_len)
	{
		if (seq[pos].second == 'W')
		{
			ll k = (b * W) / B - w;

			bool cool = false;
			for (int i = -1; i <= 1; ++i)
			{
				ll kk = k + i;
				if (kk >= 1 && (B * (w + kk) == W * b) && kk <= seq[pos].first)
				{
					k = kk;
					cool = true;
					break;
				}
			}
			
			if (cool)
			{
				++ans;
				b = 0;
				w = seq[pos].first - k;
			}
			else
			{
				w += seq[pos].first;
			}
		}
		else
		{
			ll k = (w * B) / W - b;

			bool cool = false;
			for (int i = -1; i <= 1; ++i)
			{
				ll kk = k + i;
				if (kk >= 1 && (W * (b + kk) == w * B) && kk <= seq[pos].first)
				{
					k = kk;
					cool = true;
					break;
				}
			}

			if (cool)
			{
				++ans;
				w = 0;
				b = seq[pos].first - k;
			}
			else
			{
				b += seq[pos].first;
			}
		}

		++pos;
	}

	return ans;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

	int tests;
	cin >> tests;
	for (int q = 0; q < tests; q++)
	{
		read_input();

		ll ans = solve();

		cout << ans << endl;
	}

    return 0;
}