#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-7;
const int mod = 1e9 + 7;

int x[maxn], y[maxn], r[maxn];

vector <int> g[maxn];
pair <int, int> rate[maxn];
bool clockwise[maxn];
bool used[maxn];

bool touch (int i, int j) {
	return ((x[i] - x[j])*(x[i] - x[j]) + (y[i] - y[j])*(y[i] - y[j])) == (r[i] + r[j])*(r[i] + r[j]);
}

int gcd (int a, int b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

void dfs(int v, int p = -1) {
	used[v] = true;
	if (p != -1) {
		clockwise[v] = !clockwise[p];
		int a = rate[p].X*r[p];
		int b = rate[p].Y*r[v];
		int d = gcd(a, b);
		a /= d; b /= d;
		rate[v] = mp(a, b);
	}
	for (int i = 0; i < sz(g[v]); i++)
		if (!used[g[v][i]])
			dfs(g[v][i], v);
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	int t;
	scanf("%d", &t);
	while (t--) {		
		int n;
		scanf("%d", &n);
		for (int i = 0; i < n; i++) {
			g[i].clear();
			used[i] = false;
		}

		for (int i = 0; i < n; i++)
			scanf("%d%d%d", &x[i], &y[i], &r[i]);
		for (int i = 0; i < n - 1; i++) {
			for (int j = i + 1; j < n; j++) {
				if (touch(i, j)) {
					g[i].pb(j);
					g[j].pb(i);
				}
			}
		}
		for (int i = 0; i < n; i++)
			rate[i] = mp(-1, -1);

		clockwise[0] = true;
		rate[0] = mp(1, 1);
		dfs(0);

		for (int i = 0; i < n; i++) {
			if (rate[i] == mp(-1, -1)) {
				printf("not moving\n");
				continue;
			}
			if(rate[i].Y == 1)
				printf("%d ", rate[i].X);
			else
				printf("%d/%d ", rate[i].X, rate[i].Y);
			if (clockwise[i])
				printf("clockwise\n");
			else
				printf("counterclockwise\n");
		}

	}
	return 0;
}