#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

int sum;
vi arr;
int n;

int mem[1010][9000];
bool back[1010][9000];

bool possible(int at, int l) {
    if (at == n) {
        return l == sum / 2;
    }

    if (mem[at][l] != -1) {
        return mem[at][l];
    }

    int r = sum - l;
    int p2 = l - (l & (l - 1));


    if (arr[at] <= p2) {
        if (possible(at + 1, l + arr[at])) {
            back[at][l] = true;
            mem[at][l] = 1;
            return true;
        }
    }

    { 
        r = sum - l - arr[at];
        p2 = r - (r & (r - 1));
        if (arr[at] <= p2) {
            if (possible(at + 1, arr[at])) {
                back[at][l] = false;
                mem[at][l] = 1;
                return true;
            }
        }
    }

    mem[at][l] = 0;
    return false;
}

int main() {

    int ts;
    scanf("%d\n", &ts);

    for (int t = 0; t < ts; t++) {
        scanf("%d\n", &n);

        arr = vi(n);
        sum = 0;
        for (int i = 0; i < n; i++) {
            scanf("%d", &arr[i]);
            sum += arr[i];
        }

        if ((sum & (sum - 1)) != 0) {
            printf("no\n");
            continue;
        }

        if (!possible(0,0)) {
            printf("no\n");
            continue;
        }

        int l = 0;
        for (int i = 0; i < n; i++) {
            if (back[i][l]) {
                printf("l");
                l += arr[i];
            } else {
                printf("r");
            }
        }

        printf("\n");
    }

    return 0;
}
