
#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

int main() {

    int ts;
    scanf("%d\n", &ts);

    for (int t = 0; t < ts; t++) {
        int n;
        scanf("%d\n", &n);

        int tw = 0,
            tb = 0;

        vector<pair<int, char> > arr(n);
        for (int i = 0; i < n ;i++) {
            scanf("%d %c\n", &arr[i].first, &arr[i].second);
            if (arr[i].second == 'W') {
                tw += arr[i].first;
            } else {
                tb += arr[i].first;
            }
        }

        if (tw == 0) {
            printf("%d\n", tb);
            continue;
        } else if (tb == 0) {
            printf("%d\n", tw);
            continue;
        }

        int start = 0,
            starti = 0;

        int res = 0;

        while (start < n) {

            if (starti == arr[start].first) {
                start++;
                starti = 0;
                continue;
            }

            //printf("%d,%d\n", start, starti);

            int end = start,
                endi = starti;

            int w = 0,
                b = 0;

            if (arr[start].second == 'W') {
                w++;
            } else {
                b++;
            }

            while (end < n) {

                //printf("- %d,%d (%d,%d)\n", end, endi, w, b);

                char cur = arr[end].second;
                int left = arr[end].first - endi - 1;

                //printf("%d\n", left);

                if (left == 0) {
                    end++;
                    endi = 0;

                    if (arr[end].second == 'W') {
                        w++;
                    } else {
                        b++;
                    }

                    if ((ll)w * (tw + tb) == (w + b) * (ll)tw) {
                        //printf("%d,%d - %d,%d\n", start, starti, end, endi);

                        res++;
                        start = end;
                        starti = endi + 1;
                        break;
                    }

                    continue;
                }

                int take = -1;

                if (cur == 'W') {
                    int x = (ll)b * tw - (ll)w * tb,
                        y = tb;

                    if (x % y != 0) {
                        take = left;
                    } else {
                        int k = x / y;

                        assert(k != 0);

                        if (k < 0) {
                            take = left;
                        } else if (k > left) {
                            take = left;
                        } else {
                            assert(k <= left);
                            take = k;
                        }
                    }

                } else {
                    int x = (ll)w * tb - (ll)b * tw,
                        y = tw;

                    if (x % y != 0) {
                        take = left;
                    } else {
                        int k = x / y;

                        assert(k != 0);

                        if (k < 0) {
                            take = left;
                        } else if (k > left) {
                            take = left;
                        } else {
                            assert(k <= left);
                            take = k;
                        }
                    }
                }

                //printf("taking %d\n", take);

                assert(take > 0);
                endi += take;

                assert(endi < arr[end].first);

                if (cur == 'W') w += take;
                else b += take;

                if ((ll)w * (tw + tb) == (w + b) * (ll)tw) {
                    //printf("%d,%d - %d,%d\n", start, starti, end, endi);

                    res++;
                    start = end;
                    starti = endi + 1;
                    break;
                }

                assert(endi == arr[end].first - 1);
                end++;
                endi = 0;
                if (arr[end].second == 'W') {
                    w++;
                } else {
                    b++;
                }


                if ((ll)w * (tw + tb) == (w + b) * (ll)tw) {
                    //printf("%d,%d - %d,%d\n", start, starti, end, endi);

                    res++;
                    start = end;
                    starti = endi + 1;
                    break;
                }
            }
        }

        printf("%d\n", res);
    }

    return 0;
}
