#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

const int N = 1000 + 5;
const int M = 1300;
const int V = 10000 + 5;

bool sieve[V];

int n;
int x[N], y[N], r[N];

int pcnt;
int primes[M];

int rv[N][M];

bool used[N];
int s[N][M];
bool cl[N];

void factorize(int n, int* v) {
	forn(i, pcnt) {
		v[i] = 0;
		while (n % primes[i] == 0) {
			v[i]++;
			n /= primes[i];
		}
	}
}

bool read() {
	if (scanf("%d", &n) != 1)
		return false;

	forn(i, n) {
		used[i] = false;
		scanf("%d %d %d", &x[i], &y[i], &r[i]);
		factorize(r[i], rv[i]);
	}
	return true;
}

#define sqr(x) ( (x) * (x) )
li dist2(li x1, li y1, li x2, li y2) {
	return sqr(x2 - x1) + sqr(y2 - y1);
}

const int MAXD = 5000;
const int BASE = 10;

struct bigint {
	int a[MAXD];
	int size;

	bigint() {
		memset(a, 0, sizeof(a));
		size = 1;
	}

	bigint(int v) {
		memset(a, 0, sizeof(a));
		size = 1;
		a[0] = v;
		normalize();
	}

	bigint& normalize() {
		int r = 0;
		for (int i = 0; i < size || r != 0; ++i) {
			if (i >= size)
				size = i + 1;
			r = r + a[i];
			a[i] = r % BASE;
			r = (r - a[i]) / BASE;
		}

		while (size > 1 && !a[size - 1])
			size--;

		return *this;
	}

	void print() {
		printf("%d", a[size - 1]);
		for (int i = size - 2; i >= 0; --i)
			printf("%d", a[i]);
	}
};

bigint operator *= (bigint& a, const int b) {
	forn(i, a.size)
		a.a[i] *= b;
	return a.normalize();
}

void solve() {
	used[0] = true;
	queue <int> q;
	q.push(0);
	cl[0] = true;

	while (!q.empty()) {
		int v = q.front(); q.pop();

		forn(to, n) {
			if (!used[to] && dist2(x[v], y[v], x[to], y[to]) == sqr(li(r[to] + r[v]))) {
				forn(j, pcnt)
					 s[to][j] = s[v][j] + rv[v][j] - rv[to][j];

				cl[to] = !cl[v];
				used[to] = true;
				q.push(to);
			}
		}
	}

	forn(i, n) {
		if (!used[i]) {
			puts("not moving");
			continue;
		}

		bigint en = 1, den = 1;
		bool any = false;
		forn(j, pcnt) {
			forn(_, -s[i][j]) {
				den *= primes[j];
				any = true;
			}
			forn(_, s[i][j])
				en *= primes[j];
		}

		en.print();
		if (any) {
			printf("/");
			den.print();
		}

		printf(" %sclockwise\n", !cl[i] ? "counter" : "");
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif
	for (int i = 2; i <= 10000; ++i) {
		if (!sieve[i])
			primes[pcnt++] = i;
		for (int j = i * i; j <= 10000; j += i)
			sieve[j] = true;
	}

	int t;
	scanf("%d", &t);

	while (read())
		solve();

	return 0;
}