#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

const int N = 1000 * 1000 + 5;

enum {
	NONE,
	LAST,
	FRST,
	ALL
};

int encode(string s) {
	int res = 0;
	forn(i, sz(s)) {
		res *= 28;
		if ('a' <= s[i] && s[i] <= 'z')
			res += s[i] - 'a' + 1;
		if (s[i] == '?')
			res += 27;
	}
	return res;
}

int moves[4][4][30000];
int n;
char a[N], b[N], c[N];
int dp[4][N];

void trunc(char* buf) {
	bool zero = false;
	forn(i, n) {
		if (buf[i] == 0)
			zero = true;
		if (zero)
			buf[i] = '0';
	}

	buf[n] = 0;
}

bool read() {
	if (scanf("%s %s %s", a, b, c) <= 0)
		return false;
	n = max(strlen(a), max(strlen(b), strlen(c)));

	trunc(a);
	trunc(b);
	trunc(c);

	return true;
}

const int MOD = int(1e9) + 9;

void solve() {
	forn(i, n + 1)
		forn(t, 4)
			dp[t][i] = 0;

	dp[ALL][0] = 1;

	forn(i, n) {
		string s;
		s += a[i];
		s += b[i];
		s += c[i];
		int h = encode(s);

		forn(from, 4)
			forn(to, 4)
				dp[to][i + 1] = (dp[to][i + 1] + li(dp[from][i]) * moves[from][to][h]) % MOD;
	}

	printf("%d\n", dp[NONE][n]);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	forn(i, 27)
		forn(j, 27)
			forn(k, 27) {
				string s;
				s += (i == 0 ? '0' : 'a' + i - 1);
				s += (j == 0 ? '0' : 'a' + j - 1);
				s += (k == 0 ? '0' : 'a' + k - 1);

				forn(from, 4) {
					int to = NONE;

					if ((from & FRST) && i > j)
						continue;

					if ((from & LAST) && j > k)
						continue;

					if ((from & FRST) && i == j)
						to |= FRST;

					if ((from & LAST) && j == k)
						to |= LAST;

					forn(mask, 8) {
						string t;
						bool good = true;
						forn(x, 3) {
							t += (mask & (1 << x)) ? '?' : s[x];
							if (t[x] == '?' && s[x] == '0')
								good = false;
						}

						if (!good)
							continue;

						moves[from][to][encode(t)]++;
					}
				}
			}

	int t;
	scanf("%d", &t);

	while (read())
		solve();

	return 0;
}