#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#define INF 1000000000
using namespace std;

int T, n, K;
struct Cutie
{
    int val, cost;
    bool operator <(const Cutie &A) const
    {
        if(cost == A.cost)
            return val < A.val;
        return cost < A.cost;
    }
};
Cutie v[150100];
int best[11][150100];

inline bool Bun(int profit)
{
    int i, j, sol;
    for(i = 0; i <= K; ++i)
        for(j = 0; j <= n; ++j)
            best[i][j] = INF;
    best[0][0] = 0;
    for(j = 1; j <= n; ++j)
        best[0][j] = best[0][j - 1];
    for(i = 1; i <= K; ++i)
    {
        for(j = 1; j <= n; ++j)
        {
            best[i][j] = best[i][j - 1];
            if(v[j].val - (best[i - 1][j - 1] + v[j].cost) >= profit)
                best[i][j] = min(best[i][j - 1], best[i - 1][j - 1] + v[j].cost);
        }
    }
    sol = 0;
    for(i = 1; i <= n; ++i)
        sol = max(sol, v[i].val - best[K][i - 1] - v[i].cost);
    return (sol >= profit);
}

inline int CautareBinara()
{
    int st, dr, mij, rez;
    st = 0;
    dr = 10000000;
    rez = 0;
    while(st <= dr)
    {
        mij = (st + dr) / 2;
        if(Bun(mij))
        {
            rez = mij;
            st = mij + 1;
        }
        else
            dr = mij - 1;
    }
    return rez;
}

int main ()
{
#ifdef local
    freopen ("k.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, sol;
    cin >> T;
    while(T--)
    {
        cin >> n >> K;
        for(i = 1; i <= n; ++i)
            cin >> v[i].val >> v[i].cost;
        if(K >= n)
        {
            cout << "0\n";
            continue;
        }
        if(K == 0)
        {
            sol = 0;
            for(i = 1; i <= n; ++i)
                sol = max(sol, v[i].val - v[i].cost);
            cout << sol << "\n";
            continue;
        }
        sort(v + 1, v + n + 1);
        sol = CautareBinara();
        cout << sol << "\n";
    }
    return 0;
}
