#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <math.h>
using namespace std;
typedef long long ll;
#define modul 1000000007

struct wheel {
	int x;
	int y;
	int r;
};

struct rot {
	bool dir;
	ll p;
	ll q;
};

wheel wheels[1000];
rot ans[1000];


int sqr(int a) {
	return a * a;
}

ll gcd(ll a, ll b) {
	if (a < b) swap (a, b);
	while (b) {
		a %= b;
		if (a < b) swap (a, b);
	}
	return a;
}

void print(int i) {
	if (ans[i].p == 0) {
		printf("not moving\n");
		return;
	}
	if (ans[i].q == 1) {
		printf("%lld ", ans[i].p);
		if (ans[i].dir)
			printf("clockwise\n");
		else
			printf("counterclockwise\n");
		return;
	}
	printf("%lld/%lld ", ans[i].p, ans[i].q);
	if (ans[i].dir)
		printf("clockwise\n");
	else
		printf("counterclockwise\n");
	return;
}

int main () {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t;
	scanf("%d", &t);
	for (int k = 0; k < t; ++k) {
		int n;
		scanf("%d", &n);
		for (int i = 0; i < n; ++i ) {
			int x, y, r;
			scanf("%d%d%d", &x, &y, &r);
			wheels[i].x = x;
			wheels[i].y = y;
			wheels[i].r = r;
		}
		ans[0].dir = true;
		ans[0].p = 1;
		ans[0].q = 1;
		for (int i = 1; i < n; ++i) {
			ans[i].p = 0;
		}
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				if (sqr(abs(wheels[i].x - wheels[j].x)) + sqr(abs(wheels[i].y - wheels[j].y)) == sqr(wheels[i].r + wheels[j].r) && (i != j)) {
					ans[j].dir = !ans[i].dir;
					ll p = ans[i].p * wheels[i].r;
					ll q = ans[i].q * wheels[j].r;
					if (p * q > 0) {
						ll g = gcd(p, q);
						p /= g;
						q /= g;
						ans[j].p = p;
						ans[j].q = q;
					}
				}
			}
		}
		for (int i = 0; i < n; ++i) {
			print(i);
		}
	}
	return 0;
}