#include <iostream>
#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>
#include <memory.h>

using namespace std;

const int maxn = 1024;
const int maxk = 10;

int n, m;
vector<int> e[maxn];
int a[maxn][maxn], a1[maxn * maxn], a2[maxn * maxn];
int dp[maxn][maxn];
vector<int> children[maxn];
int b[maxk][maxk];
int dp2[1 << maxk];


void dfs(int v, int p) {
	int cnt = 0;
	vector<int> o;
	for (int i = 0; i < (int)e[v].size(); i++) {
		int to = e[v][i];
		if (to == p) continue;
		dfs(to, v);
		dp[v][v] += dp[to][to];
		cnt++;
		o.push_back(to);
	}
	vector<int> can(cnt, 0);

	for (int i = 0; i < cnt; i++) for (int j = 0; j < cnt; j++) b[i][j] = 0;
	for (int i = 0; i < (int)o.size(); i++) {
		int to1 = o[i];
		for (int _ch1 = 0; _ch1 < (int)children[to1].size(); _ch1++) {
			int ch1 = children[to1][_ch1];
			if (dp[to1][ch1] != dp[to1][to1]) continue;
			if (a[v][ch1]) {
				/*dp[v][v]++;
				for (int j = 0; j < cnt; j++) b[j][i] = b[i][j] = 0;
				break;*/
				can[i] = 1;
			}

			for (int j = i + 1; j < (int)o.size(); j++) {
				int to2 = o[j];
				for (int _ch2 = 0; _ch2 < (int)children[to2].size(); _ch2++) {
					int ch2 = children[to2][_ch2];
					if (a[ch1][ch2] && dp[to1][ch1] == dp[to1][to1] && dp[to2][ch2] == dp[to2][to2]) {
						b[i][j] = b[j][i] = 1;
					}
				}
			}
		}
	}
	memset(dp2, 0, sizeof(dp2));

	for (int i = 0; i < cnt; i++) {
		for (int mask = 0; mask < 1 << i; mask++) {
			for (int j = 0; j < i; j++) {
				if ((mask & (1 << j)) == 0 && b[j][i]) {
					dp2[mask | (1 << j) | (1 << i)] = max(dp2[mask | (1 << j) | (1 << i)], dp2[mask] + 1);
				}
			}
			dp2[mask | (1 << i)] = max(dp2[mask | (1 << i)], dp2[mask] + can[i]);
		}
	}
	children[v].push_back(v);
	for (int i = 0; i < (int)o.size(); i++) {
		int to = o[i];
		for (int j = 0; j < (int)children[to].size(); j++) {
			int ch = children[to][j];
			children[v].push_back(ch);
			//dp[v][children[to][j]] = dp[v][v] + dp2[(1 << cnt) - 1 - (1 << i)];
			/*if (dp[to][ch] == dp[to][to]) {
				dp[v][ch] = dp[v][v] + dp2[(1 << cnt) - 1 - (1 << i)];
			} else {
				dp[v][ch] = 0;
			}*/
			dp[v][ch] = dp[v][v] - dp[to][to] + dp[to][ch] + dp2[(1 << cnt) - 1 - (1 << i)];
		}
	}
	dp[v][v] += dp2[(1 << cnt) - 1];
}

int main() {
	freopen("input.txt", "r", stdin);

	int T;
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &n);
		for (int i = 1; i <= n; i++) {
			e[i].clear();
			children[i].clear();
		}
		for (int i = 1; i <= n; i++) for (int j = 1; j <= n; j++) dp[i][j] = 0;
		for (int i = 1; i < n; i++) {
			int u, v;
			scanf("%d%d", &u, &v);
			e[u].push_back(v);
			e[v].push_back(u);
		}
		scanf("%d", &m);
		for (int i = 0; i < m; i++) {
			scanf("%d%d", &a1[i], &a2[i]);
			a[a1[i]][a2[i]] = a[a2[i]][a1[i]] = 1;
		}

		dfs(1, -1);
		printf("%d\n", dp[1][1]);
		for (int i = 0; i < m; i++) {
			a[a1[i]][a2[i]] = a[a2[i]][a1[i]] = 0;
		}
	}

	return 0;
}