#include <iostream>
#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>
#include <memory.h>

using namespace std;

typedef long long ll;

const int maxn = 1 << 17;
const int maxm = 16;

int n;
int a[maxn];
char c[maxn];

int sign(ll x) {
	if (x < 0) return -1;
	if (x == 0) return 0;
	return 1;
}

int main() {
	freopen("input.txt", "r", stdin);

	int T;
	scanf("%d\n", &T);
	while (T--) {
		scanf("%d\n", &n);
		int sumW = 0, sumB = 0;
		for (int i = 0; i < n; i++) {
			scanf("%d %c\n", &a[i], &c[i]);
			if (c[i] == 'B') sumB += a[i];
			if (c[i] == 'W') sumW += a[i];
		}
		
		if (sumB == 0 || sumW == 0) {
			printf("%d\n", sumW + sumB);
			continue;
		}

		int ans = 0;
		int curSumW = 0, curSumB = 0;
		for (int i = 0; i < n; i++) {
			int nextSumW = curSumW, nextSumB = curSumB;
			if (c[i] == 'B') nextSumB += a[i];
			if (c[i] == 'W') nextSumW += a[i];
			
			ll a1 = 1LL * sumW * curSumB - 1LL * sumB * curSumW;
			ll a2 = 1LL * sumW * nextSumB - 1LL * sumB * nextSumW;

			if (sign(a1) != sign(a2) && a1 != 0) {
				ans++;
				if (c[i] == 'B') {
					curSumB = nextSumB - 1LL * curSumW * sumB / sumW;
					curSumW = 0;
				}
				if (c[i] == 'W') {
					curSumW = nextSumW - 1LL * curSumB * sumW / sumB;
					curSumB = 0;					
				}
			} else {
				curSumW = nextSumW;
				curSumB = nextSumB;
			}
		}
		printf("%d\n", ans);
	}

	return 0;
}